#!/usr/bin/env python
# -*- coding: utf-8 -*-

# ----------------------------------------------------------------------
#
#    This file is part of ShoppingMortel.
#    Copyright (C) 2012-today zAmis Association
#
#    ShoppingMortel is free software: you can redistribute it and/or
#    modify it under the terms of the GNU Affero General Public License
#    as published by the Free Software Foundation, either version 3 of
#    the License, or (at your option) any later version
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details
#
#    You should have received a copy of the GNU Affero General Public
#    License along with this program.  If not, see
#    <http://www.gnu.org/licenses/>
#
# ----------------------------------------------------------------------

global _OBJ_ITEMOBJ_TPL_NBR
_OBJ_ITEMOBJ_TPL_NBR = 0
global _OBJ_ITEMOBJ_NBR
_OBJ_ITEMOBJ_NBR = 1

class ItemobjTemplate(object):
    """ ItemobjTemplate class.
    """
	
	def __init__(self, name, description, weight, tool_lst, pv_max, 
                    agility, strength, loot_inside, loot_break,
                    is_basic=True, is_unique=False, is_container=False,
                    is_weapon=False, is_tool=False):
        """ Constructor.

            :param :
        """
		global _OBJ_ITEMOBJ_TPL_NBR
		OBJ_OTPL_NBR += 1
		# descr
		self.id = _OBJ_OTPL_NBR
		self.name = name
		self.descr = descr
		self.weight = weight
		self.tool_lst = list(tools_lst)
		# durability
		self.pv_max = pv_max
		# weapons
		self.agility = agility
		self.strength = strength
		# loot
		self.loot_inside = list(loot_inside)
		self.loot_break =  list(loot_break)
		# flags
        self.is_basic = is_basic
        self.is_unique = is_unique
        self.is_container = is_container
        self.is_weapon = is_weapon
        self.is_tool = is_tool

	def __str__(self):
		return "<ItemobjTemplate (id %d)> (%s)" % (self.id, self.name)
	
	def zObjTpl_get_dump_verbose(self, prefix = ''):
		str = '%s%s: %s' % (prefix, self, self.descr)
		if not self.zObjTpl_is_basic:
			for zobj_loot_tpl in self.loot_inside:
				str += '\n%s%s' % (prefix, zobj_loot_tpl.zObjLootTpl_get_dump_verbose('\t'))
			for zobj_loot_tpl in self.loot_break:
				str += '\n%s%s' % (prefix, zobj_loot_tpl.zObjLootTpl_get_dump_verbose('\t'))
		return str

	@staticmethod
	def zObjTpl_create_basic_tpl(name, descr, weight, tool_lst = []):
		zobj = zObjTpl(name, descr, weight, tool_lst, 0, 0, 0, [], [], 1, 0, 0, 0, 0)
		return zobj

	def zObjTpl_is_basic(self): return gf_flag_get(self.flags, 0)
	def zObjTpl_is_unique(self): return gf_flag_get(self.flags, 1)
	def zObjTpl_is_container(self): return gf_flag_get(self.flags, 2)
	def zObjTpl_is_weapon(self): return gf_flag_get(self.flags, 3)
	def zObjTpl_is_tool(self): return gf_flag_get(self.flags, 4)

class Itemobj(object):
	""" Itemobject class
    """
    
	def __init__(self, itemobj_template):
        """ Constructor. """
		global _OBJ_ITEMOBJ_NBR
		_OBJ_ITEMOBJ_NBR += 1
		# descr
		self.id = _OBJ_ITEMOBJ_NBR
		self.itemobj_template = itemobj_template
		# durability
		self.pv_cur = itemobj_template.pv_max
	
	def __str__(self):
		return "<Itemobj (id %d)> (%s), pv: %d/%d" % (self.id, self.z_obj_tpl.name, self.pv_cur, self.itemobj_template.pv_max)
	
	def itemobj_get_dump_verbose(self):
		str = '%s: %s' % (self, self.itemobj_template.descr)
		return str
    
	def itemobj_destroy(self):
		# vars
		loot_itemobjs = []
		# handle loot
		break_loots = self.itemobj_template.break_loots
		for break_loot in break_loots:
			for itemobj_template in break_loot.itemobj_templates:
				loot_itemobjs.append(Itemobj(itemobj_template))
		del(self)
		return loot_itemobjs
