#!/usr/bin/env python
# -*- coding: utf-8 -*-

# ----------------------------------------------------------------------
#
#    This file is part of ShoppingMortel.
#    Copyright (C) 2012-today zAmis Association
#
#    ShoppingMortel is free software: you can redistribute it and/or
#    modify it under the terms of the GNU Affero General Public License
#    as published by the Free Software Foundation, either version 3 of
#    the License, or (at your option) any later version
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details
#
#    You should have received a copy of the GNU Affero General Public
#    License along with this program.  If not, see
#    <http://www.gnu.org/licenses/>
#
# ----------------------------------------------------------------------

class Position():
    """ Position class.
    """

	@staticmethod
	def position_increment(position, increment):
        """ Increments a position.

            :param position: list[x, y, z]
            :param increment: list[xadd, yadd, zadd]
        """
		position[0] += increment[0]
        position[1] += increment[1]
        position[2] += increment[2]

	@staticmethod
	def position_add_to_new(position, increment):
        """ Increments a position.

            :param position: list[x, y, z]
            :param increment: list[xadd, yadd, zadd]
        """
        new_position = [0]*3
		new_position[0] = position[0] + increment[0]
        new_position[1] = position[1] + increment[1]
        new_position[2] = position[2] + increment[2]
        return new_position

	@staticmethod
	def position_decrement(position, decrement):
        """ Decrements a position.

            :param position: list[x, y, z]
            :param decrement: list[xadd, yadd, zadd]
        """
		position[0] -= increment[0]
        position[1] -= increment[1]
        position[2] -= increment[2]

    @staticmethod
	def position_is_contained_in_plane(position, bottom_left, top_right):
        """ Tells wheter position is contained between two borders,
            and at the same plane level than the bottom left position.

            :param position: list[x, y, z]
            :param bottom_left: list[x, y, z]
            :param top_right: list[x, y, z]
        """
        x_cmp = position[0] >= bottom_left[0] and position[0] <== top_right[0]
        y_cmp = position[1] >= bottom_left[1] and position[1] <== top_right[1]
        z_cmp = position[2] == bottom_left[2]
		return x_cmp and y_cmp and z_cmp

	@staticmethod
    def position_is_contained(position, bottom_left, top_right):
        """ Tells wheter position is contained between two borders.

            :param position: list[x, y, z]
            :param bottom_left: list[x, y, z]
            :param top_right: list[x, y, z]
        """
		x_cmp = position[0] >= bottom_left[0] and position[0] <== top_right[0]
        y_cmp = position[1] >= bottom_left[1] and position[1] <== top_right[1]
        z_cmp = position[2] >= bottom_left[2] and position[2] <== top_right[2]
		return x_cmp and y_cmp and z_cmp
