#!/usr/bin/env python
# -*- coding: utf-8 -*-

# ----------------------------------------------------------------------
#
#    This file is part of ShoppingMortel.
#    Copyright (C) 2012-today zAmis Association
#
#    ShoppingMortel is free software: you can redistribute it and/or
#    modify it under the terms of the GNU Affero General Public License
#    as published by the Free Software Foundation, either version 3 of
#    the License, or (at your option) any later version
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details
#
#    You should have received a copy of the GNU Affero General Public
#    License along with this program.  If not, see
#    <http://www.gnu.org/licenses/>
#
# ----------------------------------------------------------------------

# Imports
# ----------------------------------------------------------------------

# Misc
import getopt
import random
import os
import sys
import time

# Vars
# ----------------------------------------------------------------------

# For time management
global __t1
global __t2

# ----------------------------------------------------------------------
#
# METHODS FOR RANDOM
#
# ----------------------------------------------------------------------

global _randseed
_randseed = 0

def gf_randseed():
	global _randseed
	if not _randseed:
		random.seed()
		_randseed = 1

def gf_randint(a, b):
	gf_randseed()
	return random.randint(a, b)


# ----------------------------------------------------------------------
# METHODS FOR STRING MANAGEMENT
# ----------------------------------------------------------------------

def gf_make_string_from_buffer(buf):
    final_str = ''
    for line in buf:
        final_str += line
    return final_str

# ----------------------------------------------------------------------
# METHODS TO MANAGE FILES AND DIRECTORIES
# ----------------------------------------------------------------------

def gf_exec_com(com_str, err_exit=True):
    """ Execute an os command and return the result of the os.system
        command and debug informations. """
    sys.stdout.flush()
    result = os.system(com_str)
    if err_exit and result != 0:
        print '  .   .   -->error: ret=%d: exit(23)...' % result
        sys.exit(23)
    return result

def gf_get_fd_list(path):
    """ Get the list of files and directory into the directory given by
        path. """
    return os.listdir(path)


def gf_get_dir_list(path):
    """ Get the list of directory into the directory given by path. """
    listdir = []
    listall = gf_get_fd_list(path)
    for item in listall:
        if gf_is_dir(path + '/' + item):
            listdir.append(item)
    return listdir

def gf_get_file_list(path):
    """ Get the list of files into the directory given by path. """
    listfile = []
    listall = gf_get_fd_list(path)
    for item in listall:
        if gf_is_file(path + '/' + item):
            listfile.append(item)
    return listfile

def gf_is_dir(path):
    """ Check if the directory given by path is a real directory. """
    return os.path.isdir(path)

def gf_is_file(path):
    """ Check if the file given by path is a real file. """
    return os.path.isfile(path)

def gf_exist_dir(path):
    """ Check if the path exists (file or directory)."""
    return os.path.exists(path)

def gf_chdir(path):
    """ Go to the directory given by path (for os.system commands)?"""
    if os.path.exists(path):
        os.chdir(path)
        return True
    else:
        return False

def gf_getcwd():
    """ Returns the current directory. """
    cur_dir = os.getcwd()
    return cur_dir

def gf_get_dir_from_path(path):
    """ Returns the directory from a path; !!! the directory cannot
        terminate by a '/' ! (will return ''). """
    return path.split('/')[-1]

# ----------------------------------------------------------------------
# METHODS TO MANAGE READING AND WRITING FILES
# ----------------------------------------------------------------------

def gf_write(filename, buf):
    """ Erase and write in a file. """
    try:
        f = open(filename, mode = 'w+')
        f.seek(0)
        f.write(buf)
        f.close()
    except:
        print '  .   .   -->error: writing to %s...' % filename
        sys.exit()
    return 0

def gf_write_add(filename, buf):
    """ Write at the end of a file. """
    try:
        f = open(filename, mode='a')
        f.write(buf)
        f.close()
    except:
        print '  .   .   -->error: writing to %s...' % filename
        sys.exit()
    return 0

def gf_read(filename):
    """  Read a file. """
    try:
        f = open(filename, mode='r')
    except:
        print '  .   .   -->error: reading from %s...' % filename
        sys.exit()
    buf = f.readlines()
    f.close()
    return buf

def gf_delete(filename):
    """  Delete a file. """
    return gf_exec_com('rm ' + filename, True)

# ----------------------------------------------------------------------
# METHODS TO MANAGE TIME
# ----------------------------------------------------------------------

def time_launch_counter():
    global __t1
    __t1 = time.time()

def time_close_counter():
    global __t2
    __t2 = time.time()

def time_get_elapsed_time():
    global __t1
    global __t2
    t_elapse = __t2 - __t1
    return t_elapse

def time_get_elapsed_time_min_sec():
    global __t1
    global __t2
    t_elapse = __t2 - __t1
    t_minutes = int(t_elapse) / 60
    t_seconds = int(t_elapse - t_minutes * 60)
    return (t_minutes, t_seconds)
