#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Imports
# ----------------------------------------------------------------------------

# Misc
import math
import sys
import getopt
import os

# Matplotlib
import	numpy					as npy
import	matplotlib.pyplot			as mplib
from		pylab					import *


# Vars
# ----------------------------------------------------------------------------


# Functions :: gen
# ----------------------------------------------------------------------------

global __mpl_gen_fig_nbr
global __mpl_gen_fig_subplot_lst
global __mpl_gen_fig
global __mpl_gen_ax

global __color_gray_lst_5
global __color_gray_lst_7
global __color_rgy_lst_3
global __color_lst
global __color_lst_inv

def Mpl_init():
	# Gen global vars
	global __mpl_gen_fig_nbr
	global __mpl_gen_fig_subplot_lst
	global __mpl_gen_fig
	global __mpl_gen_ax
	
	global __color_gray_lst_5
	global __color_gray_lst_7
	global __color_rgy_lst_3
	global __color_lst
	
	# Initialize global vars
	__mpl_gen_fig_nbr = 0
	__mpl_gen_fig_subplot_lst = []
	__mpl_gen_fig = None
	__mpl_gen_ax = None
	
	# Initialize global vars for colors
	__color_gray_lst_5 = ['0.95', '0.85', '0.60', '0.40', '0.20']
	__color_gray_lst_7 = ['0.95', '0.85', '0.70', '0.50', '0.40', '0.30', '0.20']
	__color_rgy_lst_3 = ['b', 'y', 'r']
	
	__color_gray_lst_5_inv = ['0.10', '0.25', '0.40', '0.60', '0.85']
	__color_gray_lst_7_inv = ['0.10', '0.25', '0.40', '0.60', '0.85']
	
	__color_lst_inv = __color_gray_lst_7
	__color_lst = __color_gray_lst_5_inv

def Mpl_color(idx):
	# Gen global vars
	global __color_lst
	
	return __color_lst[idx]

def Mpl_color_lst():
	# Gen global vars
	global __color_lst
	
	return __color_lst

def Mpl_color_inv(idx):
	# Gen global vars
	global __color_lst
	
	return __color_lst[idx]

def Mpl_color_lst_inv():
	# Gen global vars
	global __color_lst
	
	return __color_lst_inv
	
def Mpl_show():
	mplib.show()

def Mpl_add_figure(figsize = None):
	# Gen global vars
	global __mpl_gen_fig_nbr
	global __mpl_gen_fig_subplot_lst
	global __mpl_gen_fig
	
	# Add figure
	__mpl_gen_fig_nbr += 1
	__mpl_gen_fig_subplot_lst.append([1, 1, 1])
	
	__mpl_gen_fig = mplib.figure(__mpl_gen_fig_nbr, figsize = figsize)

def Mpl_add_subplot(zorder = 1):
	# Gen global vars
	global __mpl_gen_fig_nbr
	global __mpl_gen_fig_subplot_lst
	global __mpl_gen_fig
	global __mpl_gen_ax
	
	# Add subplot
	cur_subplot = __mpl_gen_fig_subplot_lst[__mpl_gen_fig_nbr-1]
	if (cur_subplot[2] > cur_subplot[0] * cur_subplot[1]):
		cur_subplot[0] = cur_subplot[0] + 1
	
	__mpl_gen_ax = __mpl_gen_fig.add_subplot(cur_subplot[0], cur_subplot[1], cur_subplot[2], zorder = zorder)

def Mpl_add_figure_and_subplot(figsize = None, zorder = 1):
	Mpl_add_figure(figsize)
	Mpl_add_subplot(zorder)

def Mpl_subplot_adjust(left = None, bottom = None, right = None, top = None, wspace = None, hspace = None):
	# Gen global vars
	global __mpl_gen_fig
	
	__mpl_gen_fig.subplots_adjust(left = left, bottom = bottom, right = right, top = top,  wspace = wspace, hspace = hspace) 


# Functions :: pie
# ***************************************************************************

global __mpl_pie_slice_nbr

def Mpl_pie_init(slice_nbr):
	# Global vars
	global __mpl_pie_slice_nbr
	
	__mpl_pie_slice_nbr = slice_nbr

def Mpl_pie_pie(fracs, explode, labels, autopct = '%1.1f%%', shadow = False, colors = None):
	# Global vars
	global __mpl_pie_slice_nbr
	
	if len(fracs) != __mpl_pie_slice_nbr: print 'caca !'
	mplib.pie(fracs, explode = explode, labels = labels, autopct = autopct, shadow = shadow, colors = colors)


# Functions :: bar plot
# ***************************************************************************

global __mpl_bar_bar_nbr
global __mpl_bar_bar_cur_nbr
global __mpl_bar_bar_width
global __mpl_bar_x_nbr
global __mpl_bar_x_val
global __mpl_bar_rects_lst

def Mpl_bar_init(bar_nbr, x_nbr, bar_width):
	# Global vars
	global __mpl_bar_bar_nbr
	global __mpl_bar_bar_cur_nbr
	global __mpl_bar_bar_width
	global __mpl_bar_x_nbr
	global __mpl_bar_x_val
	global __mpl_bar_rects_lst
	
	# Init global vars
	__mpl_bar_bar_nbr = bar_nbr
	__mpl_bar_bar_cur_nbr = 0
	__mpl_bar_bar_width = bar_width
	__mpl_bar_x_nbr = x_nbr
	__mpl_bar_x_val = [None] * bar_nbr
	__mpl_bar_rects_lst = []

def Mpl_bar_add_bidouille_for_axis(y_value):
	Mpl_plot_init()
	Mpl_plot_add_plot([0.0, 9.0], [y_value, y_value], color = 'k', linestyle = 'solid', linewidth = 1, markersize = 0, zorder = 5)

def Mpl_bar_add_x_val(x_val_lst, yerr, color = 'r', linewidth = 1, bottom = 0, zorder = 1, use_mean = 1, decal = 0.0):
	# Global vars
	global __mpl_bar_bar_cur_nbr
	global __mpl_bar_bar_width
	global __mpl_bar_rects_lst
	
	if bottom != 0:
		ind_dev = (__mpl_bar_bar_cur_nbr -1) * __mpl_bar_bar_width
	else:
		ind_dev = __mpl_bar_bar_cur_nbr * __mpl_bar_bar_width
	
	if use_mean:
		ind = Mpl_bar_get_x_ind_with_mean() + decal
	else:
		ind = Mpl_bar_get_x_ind() + decal
	
	rects = mplib.bar(ind + ind_dev, x_val_lst, __mpl_bar_bar_width, color = color, yerr = yerr, linewidth = linewidth, bottom = bottom, zorder = zorder)
	
	if bottom == 0:
		__mpl_bar_bar_cur_nbr += 1
	__mpl_bar_rects_lst.append(rects)

def Mpl_bar_add_legends(legend_list, loc_arg = 'upper right', shadow_arg = False):
	# Global vars
	global __mpl_bar_x_nbr
	global __mpl_bar_rects_lst
	global __mpl_gen_ax
	
	tmp_lst = []
	for rects in __mpl_bar_rects_lst:
		tmp_lst.append(rects[0])
	
	__mpl_gen_leg = __mpl_gen_ax.legend(tuple(tmp_lst), tuple(legend_list), loc = loc_arg, shadow = shadow_arg)

def Mpl_bar_add_xticks(xticks_list, ha = 'center', va = 'baseline', fontsize = 12, rotation = 0, zorder = 1, use_mean = 1, y = -0.03, x = 0.0):
	# Global vars
	global __mpl_bar_bar_nbr
	global __mpl_bar_rects_lst
	global __mpl_bar_bar_width
	global __mpl_gen_ax
	
	if use_mean:
		ind = Mpl_bar_get_x_ind_with_mean()
	else:
		ind = Mpl_bar_get_x_ind()
	
	#ind_dev = len(__mpl_bar_rects_lst) * __mpl_bar_bar_width / 2
	ind_dev = __mpl_bar_bar_nbr * __mpl_bar_bar_width / 2 + x
	#mplib.xticks(ind + ind_dev, tuple(xticks_list), ha = 'center', va = 'top')
	
	__mpl_gen_ax.set_xticks(ind + ind_dev)
	xtickNames = __mpl_gen_ax.set_xticklabels(xticks_list)
	mplib.setp(xtickNames, ha = ha, va = va, y = y, rotation = rotation, fontsize = fontsize, zorder = zorder)


# Functions :: clacssic plot
# ***************************************************************************

global __mpl_plot_plot_nbr

def Mpl_plot_init():
	# Global vars
	global __mpl_plot_plot_nbr
	
	__mpl_plot_plot_nbr = 0

def Mpl_plot_add_plot(x_lst, y_lst, color = 'k', linestyle = 'dashed', linewidth = 1, marker = 'o', markerfacecolor = 'k', markersize = 12, zorder = 1):
	# Global vars
	global __mpl_gen_ax
	global __mpl_plot_plot_nbr
	
	__mpl_plot_plot_nbr += 1
	__mpl_gen_ax.plot(x_lst, y_lst, color = color, linestyle = linestyle, linewidth = linewidth, marker = marker, markerfacecolor = markerfacecolor, markersize = markersize, zorder = zorder)

def Mpl_plot_add_plot_semilogx(x_lst, y_lst, color = 'k', linestyle = 'dashed', linewidth = 1, marker = 'o', markerfacecolor = 'k', markersize = 12, zorder = 1):
	# Global vars
	global __mpl_gen_ax
	global __mpl_plot_plot_nbr
	
	__mpl_plot_plot_nbr += 1
	__mpl_gen_ax.semilogx(x_lst, y_lst, color = color, linestyle = linestyle, linewidth = linewidth, marker = marker, markerfacecolor = markerfacecolor, markersize = markersize, zorder = zorder)

def Mpl_plot_add_plot_semilogy(x_lst, y_lst, color = 'k', linestyle = 'dashed', linewidth = 1, marker = 'o', markerfacecolor = 'k', markersize = 12, zorder = 1):
	# Global vars
	global __mpl_gen_ax
	global __mpl_plot_plot_nbr
	
	__mpl_plot_plot_nbr += 1
	__mpl_gen_ax.semilogy(x_lst, y_lst, color = color, linestyle = linestyle, linewidth = linewidth, marker = marker, markerfacecolor = markerfacecolor, markersize = markersize, zorder = zorder)

def Mpl_plot_add_plot_loglog(x_lst, y_lst, color = 'k', linestyle = 'dashed', linewidth = 1, marker = 'o', markerfacecolor = 'k', markersize = 12, zorder = 1):
	# Global vars
	global __mpl_gen_ax
	global __mpl_plot_plot_nbr
	
	__mpl_plot_plot_nbr += 1
	__mpl_gen_ax.loglog(x_lst, y_lst, color = color, linestyle = linestyle, linewidth = linewidth, marker = marker, markerfacecolor = markerfacecolor, markersize = markersize, zorder = zorder)

def Mpl_plot_add_legends(legend_list, loc_arg = 'upper right', shadow_arg = False):
	# Global vars
	global __mpl_gen_ax
	global __mpl_plot_plot_nbr
	
	__mpl_gen_leg = __mpl_gen_ax.legend(tuple(legend_list), loc = loc_arg, shadow = shadow_arg)

def Mpl_plot_logx_set_values():
	# Global vars
	global __mpl_gen_ax
	
	formatter = FuncFormatter(Mpl_log_10_product)
	__mpl_gen_ax.xaxis.set_major_formatter(formatter)

def Mpl_plot_logy_set_values():
	# Global vars
	global __mpl_gen_ax
	
	formatter = FuncFormatter(Mpl_log_10_product)
	__mpl_gen_ax.yaxis.set_major_formatter(formatter)


# Functions :: axis
# ***************************************************************************

def Mpl_set_axis(x_begin, x_end, y_begin, y_end, zorder = 1):
	mplib.axis([x_begin, x_end, y_begin, y_end], zorder = zorder)


# Functions :: grid
# ***************************************************************************

def Mpl_grid_enable(color = 'k', linestyle = 'dashed', linewidth = 1):
	Mpl_grid_enable_x(color, linestyle, linewidth)
	Mpl_grid_enable_y(color, linestyle, linewidth)

def Mpl_grid_enable_x(color = 'k', linestyle = 'dashed', linewidth = 1, zorder = 1):
	global __mpl_gen_ax
	__mpl_gen_ax.xaxis.grid(color = color, linestyle = linestyle, linewidth = linewidth, zorder = zorder)

def Mpl_grid_enable_y(color = 'k', linestyle = 'dashed', linewidth = 1, zorder = 1):
	global __mpl_gen_ax
	__mpl_gen_ax.yaxis.grid(color = color, linestyle = linestyle, linewidth = linewidth, zorder = zorder)

def Mpl_grid_disable():
	global __mpl_gen_ax
	__mpl_gen_ax.grid(False)


# Functions :: labels
# ***************************************************************************

def Mpl_bar_autolabel(rects):
	# attach some text labels
	for rect in rects:
		height = rect.get_height()
		mplib.text(rect.get_x()+rect.get_width()/2., 1.05*height, '%d'%int(height), ha='center', va='bottom')

def Mpl_set_ylabel(msg, fontsize = 12, color = 'k'):
	global __mpl_gen_ax
	__mpl_gen_ax.set_ylabel(msg, fontsize = fontsize, color = color)

def Mpl_set_xlabel(msg, fontsize = 12, color = 'k'):
	global __mpl_gen_ax
	__mpl_gen_ax.set_xlabel(msg, fontsize = fontsize, color = color)

def Mpl_set_title(msg, fontsize = 12, color = 'k'):
	global __mpl_gen_ax
	__mpl_gen_ax.set_title(msg, fontsize = fontsize, color = color)

def Mpl_add_text(x_coord, y_coord, msg, fontsize = 12, color = 'k'):
	mplib.text(x_coord, y_coord, msg, fontsize = fontsize, color = color)

def Mpl_annotate(x_dst_coord, y_dst_coord, x_txt_begin_coord, y_txt_begin_coord, msg, facecolor_arg, shrink_arg):
	mplib.annotate(msg, xy=(x_dst_coord, y_dst_coord), xytext=(x_txt_begin_coord, y_txt_begin_coord), arrowprops=dict(facecolor=facecolor_arg, shrink=shrink_arg) )


# Functions :: misc
# ***************************************************************************

def Mpl_bar_get_x_ind_with_mean():
	global __mpl_bar_x_nbr
	ind = npy.arange(__mpl_bar_x_nbr)
	ind[-1] += 1
	return ind

def Mpl_bar_get_x_ind():
	global __mpl_bar_x_nbr
	ind = npy.arange(__mpl_bar_x_nbr)
	return ind

def Mpl_log_10_product(x, pos):
	#return '%1i' % (x) // orgi
	return '%1.2f' % (x)
